vsg: vsg::Commands Class Reference

vsg 1.1.13 VulkanSceneGraph library

Loading...
Searching...
No Matches
vsg::Commands Class Reference

`#include <Commands.h>`

Inheritance diagram for vsg::Commands:
[legend]
Collaboration diagram for vsg::Commands:
[legend]

## Public Types
using | Children = std::vector<ref_ptr<vsg::Command>>

## Public Member Functions
| Commands (size_t numChildren=0)
void | traverse (Visitor &visitor) override
void | traverse (ConstVisitor &visitor) const override
void | traverse (RecordTraversal &visitor) const override
int | compare (const Object &rhs) const override
| compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,
void | read (Input &input) override
void | write (Output &output) const override
void | addChild (vsg::ref_ptr< Command > child)
void | compile (Context &context) override
void | record (CommandBuffer &commandBuffer) const override
Public Member Functions inherited from vsg::Inherit< Command, Commands >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
Public Member Functions inherited from vsg::Command
| Command (const Command &rhs, const CopyOp &copyop={})
Public Member Functions inherited from vsg::Inherit< Compilable, Command >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
Public Member Functions inherited from vsg::Compilable
| Compilable (const Compilable &rhs, const CopyOp &copyop={})
Public Member Functions inherited from vsg::Inherit< Node, Compilable >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
Public Member Functions inherited from vsg::Node
| Node (const Node &rhs, const CopyOp &copyop={})
ref_ptr< Object > | clone (const CopyOp &copyop={}) const override
Public Member Functions inherited from vsg::Inherit< Object, Node >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual void | accept (ConstVisitor &visitor) const
virtual void | accept (RecordTraversal &visitor) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Static Public Member Functions
template<class N, class V>
static void | t_traverse (N &node, V &visitor)
Static Public Member Functions inherited from vsg::Inherit< Command, Commands >
static ref_ptr< Commands > | create (Args &&... args)
static ref_ptr< Commands > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Inherit< Compilable, Command >
static ref_ptr< Command > | create (Args &&... args)
static ref_ptr< Command > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Inherit< Node, Compilable >
static ref_ptr< Compilable > | create (Args &&... args)
static ref_ptr< Compilable > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Node
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_NODES_OBJECTS
static void | operator delete (void *ptr)
Static Public Member Functions inherited from vsg::Inherit< Object, Node >
static ref_ptr< Node > | create (Args &&... args)
static ref_ptr< Node > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)

## Public Attributes
Children | children

## Additional Inherited Members
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

Commands is a command that acts as a container for other commands. vsg::Commands is functionally equivalent to vsg::Group but is faster thanks to lower CPU overhead in applying the state stack prior to vsg::Command calls.

## Member Function Documentation

## ◆ compare()

int vsg::Commands::compare | ( | const Object & | rhs | ) | const
| overridevirtual

compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,

Reimplemented from vsg::Object.

## ◆ compile()

void vsg::Commands::compile | ( | Context & | context | ) |
| overridevirtual

Reimplemented from vsg::Compilable.

## ◆ read()

void vsg::Commands::read | ( | Input & | input | ) |
| overridevirtual

Reimplemented from vsg::Object.

## ◆ record()

void vsg::Commands::record | ( | CommandBuffer & | commandBuffer | ) | const
| overridevirtual

Implements vsg::Command.

## ◆ traverse() [1/3]

void vsg::Commands::traverse | ( | ConstVisitor & | visitor | ) | const
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ traverse() [2/3]

void vsg::Commands::traverse | ( | RecordTraversal & | visitor | ) | const
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ traverse() [3/3]

void vsg::Commands::traverse | ( | Visitor & | visitor | ) |
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ write()

void vsg::Commands::write | ( | Output & | output | ) | const
| overridevirtual

Reimplemented from vsg::Object.

The documentation for this class was generated from the following file:

- include/vsg/commands/Commands.h